## libgit2 0.17.0

=== debian/changelog ===
libgit2 (0.17.0-1) experimental; urgency=low

  * New Upstream Release.
  * debian/patches/build_static.patch: Enables building as both
    static and dynamic library.
  * debian/rules: Added CMAKE_BUILD_TYPE=RelWithDebInfo to rules file.
  * debian/compat: Updated to 9, adds support for hardening.

 -- Russell Sim <russell.sim@gmail.com>  Sun, 20 May 2012 21:34:12 +1000

libgit2 (0.16.0-1) experimental; urgency=low

  * Initial release (Closes: #614517)

 -- Russell Sim <russell.sim@gmail.com>  Tue, 06 Mar 2012 23:03:20 +1100
