=== debian/control ===
Source: libgit2
Section: libs
Priority: extra
Maintainer: Russell Sim <russell.sim@gmail.com>
Build-Depends: debhelper (>= 9.20120417), python-all (>= 2.4.0), cmake, libz-dev
Standards-Version: 3.9.3
Homepage: http://libgit2.github.com/
#Vcs-Git: git://git.debian.org/collab-maint/libgit2.git
#Vcs-Browser: http://git.debian.org/?p=collab-maint/libgit2.git;a=summary


Package: libgit2-dev
Architecture: any
Section: libdevel
Depends: libgit2-0 (= ${binary:Version}),
         ${misc:Depends}
Description: low-level Git library (development files)
 libgit2 is a portable, pure C implementation of the Git
 distributed version control system core methods provided as a
 re-entrant link-able library with a solid API.
 .
 This package contains the development files for libgit2.

Package: libgit2-0
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: low-level Git library
 libgit2 is a portable, pure C implementation of the Git
 distributed version control system core methods provided as a
 re-entrant link-able library with a solid API.

Package: libgit2-dbg
Section: debug
Architecture: any
Depends: libgit2-0 (= ${binary:Version}),
         ${misc:Depends}
Description: libgit2 library and debugging symbols
 libgit2 is a portable, pure C implementation of the Git
 distributed version control system core methods provided as a
 re-entrant link-able library with a solid API.
 .
 This package contains detached debugging symbols.
 .
 Most people will not need this package.
