=== debian/watch ===
version=2
https://github.com/libgit2/libgit2/downloads /downloads/libgit2/libgit2/libgit2-(.+)\.tar\.gz
