## libgit2 0.19.0

=== debian/changelog ===
libgit2 (0.19.0-2) experimental; urgency=low

  * Added correct dependencies to development package. (Closes: #715173)
  * Standards upgrade to version 3.9.4.
  * Multi-arch support.
  * Manually specified symbols instead of relying on regex.

 -- Russell Sim <russell.sim@gmail.com>  Wed, 20 Aug 2013 22:33:20 +1000

libgit2 (0.19.0-1) experimental; urgency=low

  * Enable threading. (Closes: #700181)

 -- Russell Sim <russell.sim@gmail.com>  Tue, 02 Jul 2013 19:43:00 +1000

libgit2 (0.18.0-2) experimental; urgency=low

  * Disable online tests.
    Thanks to Felix Geyer for the heads up. (Closes: #712300)

 -- Russell Sim <russell.sim@gmail.com>  Mon, 17 Jun 2013 23:11:15 +1000

libgit2 (0.18.0-1) experimental; urgency=low

  [ Russell Sim ]
  * Added examples to dev package.

  [ Carlos Martín Nieto ]
  * Build-Depend on python-minimal instead of -all
  * BUILD_TESTS isn't used in this project

  [ Russell Sim ]
  * New upstream release 0.18.0.

 -- Russell Sim <russell.sim@gmail.com>  Tue, 30 Apr 2013 00:55:09 +1000
