=== debian/control ===
Source: libgit2
Section: libs
Priority: extra
Maintainer: Russell Sim <russell.sim@gmail.com>
Build-Depends: debhelper (>= 9.20120417), python-minimal (>= 2.4.0),
               cmake, libz-dev, libssl-dev, ca-certificates
Standards-Version: 3.9.4
Homepage: http://libgit2.github.com/
Vcs-Git: git://anonscm.debian.org/users/arrsim-guest/libgit2.git
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=users/arrsim-guest/libgit2.git;a=summary


Package: libgit2-dev
Architecture: any
Section: libdevel
Multi-Arch: same
Depends: libgit2-0 (= ${binary:Version}), libz-dev, libssl-dev,
         ${shlibs:Depends}, ${misc:Depends}
Description: low-level Git library (development files)
 libgit2 is a portable, pure C implementation of the Git
 distributed version control system core methods provided as a
 re-entrant link-able library with a solid API.
 .
 This package contains the development files for libgit2.

Package: libgit2-0
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: low-level Git library
 libgit2 is a portable, pure C implementation of the Git
 distributed version control system core methods provided as a
 re-entrant link-able library with a solid API.

Package: libgit2-dbg
Section: debug
Architecture: any
Multi-Arch: same
Depends: libgit2-0 (= ${binary:Version}),
         ${misc:Depends}
Description: libgit2 library and debugging symbols
 libgit2 is a portable, pure C implementation of the Git
 distributed version control system core methods provided as a
 re-entrant link-able library with a solid API.
 .
 This package contains detached debugging symbols.
 .
 Most people will not need this package.
