=== debian/watch ===
version=3
https://github.com/libgit2/libgit2/tags /libgit2/libgit2/archive/v(.+)\.tar\.gz
