=== debian/control ===
--- 
+++ 
@@ -4,7 +4,7 @@
 Maintainer: Russell Sim <russell.sim@gmail.com>
 Build-Depends: debhelper (>= 9.20120417), python-minimal (>= 2.4.0),
                cmake, libz-dev, libssl-dev, ca-certificates
-Standards-Version: 3.9.4
+Standards-Version: 3.9.5
 Homepage: http://libgit2.github.com/
 Vcs-Git: git://anonscm.debian.org/users/arrsim-guest/libgit2.git
 Vcs-Browser: http://anonscm.debian.org/gitweb/?p=users/arrsim-guest/libgit2.git;a=summary
