=== debian/changelog ===
libgit2 (0.21.1-3~bpo7+1) wheezy-backports; urgency=medium

  * Rebuild for wheezy-backports.

 -- Antoine Beaupré <anarcat@debian.org>  Fri, 05 Jun 2015 10:26:49 -0400

libgit2 (0.21.1-3) jessie; urgency=medium

  * Backported fix for case insensitive filesystems (CVE-2014-9390).
    (Closes: #774048)

 -- Russell Sim <russell.sim@gmail.com>  Tue, 10 Feb 2015 20:29:05 +1100

libgit2 (0.21.1-2.1) jessie; urgency=medium

  * Non-maintainer upload.
  * Use CURDIR instead of PWD to fix the previous upload (Closes: #761539).

 -- Ivo De Decker <ivodd@debian.org>  Thu, 08 Jan 2015 23:51:20 +0100

libgit2 (0.21.1-2) jessie; urgency=medium

  * Fix buildd errors. (Closes: #761539)

 -- Russell Sim <russell.sim@gmail.com>  Sun, 04 Jan 2015 13:13:57 +1100

libgit2 (0.21.1-1) unstable; urgency=medium

  * New upstream release 0.21.1.

 -- Russell Sim <russell.sim@gmail.com>  Wed, 03 Sep 2014 12:41:44 +1000

libgit2 (0.21.0-1) UNRELEASED; urgency=medium

  * New upstream release 0.21.0.
  * debian/copyright: Added new licenses: ICS, CC0.
  * Library name now matches so name version.

 -- Russell Sim <russell.sim@gmail.com>  Sat, 21 Jun 2014 11:19:23 +1000
