=== debian/rules ===
--- 
+++ 
@@ -36,6 +36,12 @@
 	dh_auto_install --builddirectory=build-debian-release
 	dh_auto_install --builddirectory=build-debian-devel
 
+override_dh_auto_test:
+	mkdir -p build-debian-release/tmp
+	TMPDIR=$(CURDIR)/build-debian-release/tmp dh_auto_test --builddirectory=build-debian-release
+	mkdir -p build-debian-devel/tmp
+	TMPDIR=$(CURDIR)/build-debian-devel/tmp dh_auto_test --builddirectory=build-debian-devel
+
 override_dh_strip:
 	dh_strip --dbg-package=libgit2-dbg
