## libgit2 0.21.3

=== debian/changelog ===
libgit2 (0.21.3-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Use CURDIR instead of PWD to fix the previous upload (Closes: #761539).

 -- Ivo De Decker <ivodd@debian.org>  Thu, 08 Jan 2015 23:04:40 +0100

libgit2 (0.21.3-1) unstable; urgency=medium

  * New upstream release 0.21.3 (CVE-2014-9390) (Closes: #774048).
  * debian/rules: Run tests in a local tmpdir to fix FTBFS (Closes: #761539).

 -- Russell Sim <russell.sim@gmail.com>  Sun, 28 Dec 2014 18:52:18 +1100

libgit2 (0.21.2-2) unstable; urgency=medium

  * debian/control: Added missing dependencies. (Closes: #768482)

 -- Russell Sim <russell.sim@gmail.com>  Sun, 16 Nov 2014 10:33:23 +0100

libgit2 (0.21.2-1) unstable; urgency=medium

  * New upstream release 0.21.2.
  * debian/control: Added libssh2-1-dev requirement. (Closes: #761042)
  * debian/control: Added libhttp-parser-dev requirement.
  * debian/copyright: Fixed MIT NGINX license format.
  * debian/copyright: Reordered file sections.
  * debian/copyright: Fixed incorrect clar licensing.
  * Bumped standards version to 3.9.6 (no change necessary).

 -- Russell Sim <russell.sim@gmail.com>  Tue, 28 Oct 2014 20:34:58 +1100
