=== debian/control ===
--- 
+++ 
@@ -3,8 +3,9 @@
 Priority: extra
 Maintainer: Russell Sim <russell.sim@gmail.com>
 Build-Depends: debhelper (>= 9.20120417), python-minimal (>= 2.4.0),
-               cmake, libz-dev, libssl-dev, ca-certificates
-Standards-Version: 3.9.5
+               cmake, libz-dev, libssl-dev, libssh2-1-dev, libhttp-parser-dev,
+               ca-certificates
+Standards-Version: 3.9.6
 Homepage: http://libgit2.github.com/
 Vcs-Git: git://anonscm.debian.org/users/arrsim-guest/libgit2.git
 Vcs-Browser: http://anonscm.debian.org/gitweb/?p=users/arrsim-guest/libgit2.git;a=summary
@@ -14,7 +15,8 @@
 Architecture: any
 Section: libdevel
 Multi-Arch: same
-Depends: libgit2-0 (= ${binary:Version}), libz-dev, libssl-dev,
+Depends: libgit2-21 (= ${binary:Version}), libz-dev,
+         libssl-dev, libssh2-1-dev, libhttp-parser-dev,
          ${shlibs:Depends}, ${misc:Depends}
 Description: low-level Git library (development files)
  libgit2 is a portable, pure C implementation of the Git
@@ -23,7 +25,7 @@
  .
  This package contains the development files for libgit2.
 
-Package: libgit2-0
+Package: libgit2-21
 Architecture: any
 Multi-Arch: same
 Pre-Depends: ${misc:Pre-Depends}
@@ -37,7 +39,7 @@
 Section: debug
 Architecture: any
 Multi-Arch: same
-Depends: libgit2-0 (= ${binary:Version}),
+Depends: libgit2-21 (= ${binary:Version}),
          ${misc:Depends}
 Description: libgit2 library and debugging symbols
  libgit2 is a portable, pure C implementation of the Git
