=== debian/control ===
--- 
+++ 
@@ -1,10 +1,11 @@
 Source: libgit2
 Section: libs
 Priority: extra
-Maintainer: Russell Sim <russell.sim@gmail.com>
+Maintainer: Kubuntu Developers <kubuntu-devel@lists.ubuntu.com>
+XSBC-Original-Maintainer: Russell Sim <russell.sim@gmail.com>
 Build-Depends: debhelper (>= 9.20120417), python-minimal (>= 2.4.0),
                cmake, libz-dev, libssl-dev, libssh2-1-dev, libhttp-parser-dev,
-               ca-certificates
+               ca-certificates, pkg-config
 Standards-Version: 3.9.6
 Homepage: http://libgit2.github.com/
 Vcs-Git: git://anonscm.debian.org/users/arrsim-guest/libgit2.git
@@ -15,7 +16,7 @@
 Architecture: any
 Section: libdevel
 Multi-Arch: same
-Depends: libgit2-21 (= ${binary:Version}), libz-dev,
+Depends: libgit2-22 (= ${binary:Version}), libz-dev,
          libssl-dev, libssh2-1-dev, libhttp-parser-dev,
          ${shlibs:Depends}, ${misc:Depends}
 Description: low-level Git library (development files)
@@ -25,7 +26,7 @@
  .
  This package contains the development files for libgit2.
 
-Package: libgit2-21
+Package: libgit2-22
 Architecture: any
 Multi-Arch: same
 Pre-Depends: ${misc:Pre-Depends}
@@ -39,7 +40,7 @@
 Section: debug
 Architecture: any
 Multi-Arch: same
-Depends: libgit2-21 (= ${binary:Version}),
+Depends: libgit2-22 (= ${binary:Version}),
          ${misc:Depends}
 Description: libgit2 library and debugging symbols
  libgit2 is a portable, pure C implementation of the Git
