=== debian/control ===
--- 
+++ 
@@ -1,11 +1,10 @@
 Source: libgit2
 Section: libs
 Priority: extra
-Maintainer: Kubuntu Developers <kubuntu-devel@lists.ubuntu.com>
-XSBC-Original-Maintainer: Russell Sim <russell.sim@gmail.com>
-Build-Depends: debhelper (>= 9.20120417), python-minimal (>= 2.4.0),
+Maintainer: Russell Sim <russell.sim@gmail.com>
+Build-Depends: debhelper (>= 9.20120417), python-minimal (>= 2.4.0), pkg-config,
                cmake, libz-dev, libssl-dev, libssh2-1-dev, libhttp-parser-dev,
-               ca-certificates, pkg-config
+               ca-certificates
 Standards-Version: 3.9.6
 Homepage: http://libgit2.github.com/
 Vcs-Git: git://anonscm.debian.org/users/arrsim-guest/libgit2.git
